/*
 *	HT Editor
 *	htclipboard.h
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __HTCLIPBOARD_H__
#define __HTCLIPBOARD_H__

#include "global.h"
#include "htstream.h"
#include "htviewer.h"

/*
 *	CLASS ht_clipboard
 */

class ht_clipboard: public ht_mem_stream {
public:
	ht_collection *copy_history;
	dword clipboard_start, clipboard_size;

			void init();
	virtual	void done();
};

/*
 *	CLASS ht_clipboard_viewer
 */

class ht_clipboard_viewer: public ht_uviewer {
public:
			void init(bounds *b, char *desc, ht_clipboard *clipboard, int caps);
};

/* clipboard functions */

int clipboard_copy(char *source_desc, void *buf, dword len);
int clipboard_copy(char *source_desc, ht_stream *stream, dword offset, dword len);
int clipboard_paste(void *buf, dword maxlen);
int clipboard_paste(ht_stream *stream, dword offset);
int clipboard_clear();
dword clipboard_getsize();

/*
 *	INIT
 */

int init_clipboard();

/*
 *	DONE
 */

int done_clipboard();

/**/

extern ht_clipboard *clipboard;

#endif /* __HTCLIPBOARD_H__ */
