/* 
 *	HT Editor
 *	htexpl.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htexpl.h"

#include <string.h>

#define MAX_DESC_COUNT 32

struct desc_s {
	int table_id;
	int_hash *hash;
};

desc_s *desc[MAX_DESC_COUNT];
int desc_count=0;

int_hash *find_desc(int table_id)
{
	for (int i=0; i<desc_count; i++) {
		if (desc[i]->table_id==table_id) return desc[i]->hash;
	}
	return 0;
}

void register_desc(int table_id, int_hash *hash)
{
	if (!find_desc(table_id)) {
		desc_s *e=new desc_s;
		e->table_id=table_id;
		e->hash=hash;
		desc[desc_count++]=e;
		assert(desc_count<MAX_DESC_COUNT);
	}
}

int unregister_desc(int table_id)
{
	for (int i=0; i<desc_count; i++) {
		if (desc[i]->table_id==table_id) {
			delete desc[i];
			desc_count--;
			memmove(desc[i], desc[i+1], (desc_count-i)* sizeof desc[i]);
			return 1;
		}
	}
	return 0;
}

