/* 
 *	HT Editor
 *	htmz.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htmz.h"
#include "htmzhead.h"
#include "htmzrel.h"
#include "htmzimg.h"
#include "htstream.h"

viewer_if *htmz_ifs[] = {
	&htmzheader_if,
	&htmzimage_if,
	0
};

ht_view *htmz_init(bounds *b, ht_stream *file, ht_group *group)
{
	word magic;
	file->seek(0);
	file->read(&magic, 2);
	if (magic!=IMAGE_MZ_MAGIC) return 0;

	ht_mz *g=new ht_mz();
	g->init(b, file, htmz_ifs);
/*	insert_int(g, file, &htmzheader_int);
	insert_int(g, file, &htmzrel_int);
	insert_int(g, file, &htmzimage_int);*/
	return g;
}

viewer_if htmz_if = {
	htmz_init,
	0
};

void ht_mz::init(bounds *b, ht_stream *file, viewer_if **ifs)
{
	ht_viewergroup::init(b, VO_SELECTABLE | VO_BROWSABLE | VO_RESIZE, DESC_MZ, file, 0);
	mz_shared=new ht_mz_shared_data;
	file->seek(0);
	file->read(&mz_shared->header, sizeof mz_shared->header);
	shared_data=mz_shared;
	ht_viewergroup::initall(ifs);
}

void ht_mz::done()
{
	ht_viewergroup::done();
}

