/* 
 *	HT Editor
 *	htne.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htapp.h"
#include "htne.h"
#include "htneent.h"
#include "htnehead.h"
#include "htnenms.h"
#include "htneobj.h"
#include "htnewexe.h"
#include "nestruct.h"

viewer_if *htne_ifs[] = {
	&htneheader_if,
	&htnesegments_if,
	&htnenames_if,
	&htneentrypoints_if,
	0
};

ht_view *htne_init(bounds *b, ht_stream *file, ht_group *group)
{
	dword nemagic=0;
	STREAMOFS h=get_newexe_header_ofs(file);
	file->seek(h);
	file->read(&nemagic, 2);
	if (nemagic!=NE_MAGIC) return 0;

	ht_ne *g=new ht_ne();
	g->init(b, file, htne_ifs, h);
	return g;
}

viewer_if htne_if = {
	htne_init,
	0
};

void ht_ne::init(bounds *b, ht_stream *file, viewer_if **ifs, STREAMOFS h)
{
	ht_viewergroup::init(b, VO_BROWSABLE | VO_SELECTABLE | VO_RESIZE, DESC_NE, file, 0);
	VIEW_DEBUG_NAME("ht_ne");

	LOG("%s: NE: found header at %08x", file->get_name(), h);
	ne_shared=new ht_ne_shared_data;
	ne_shared->hdr_ofs=h;
	file->seek(h);
	file->read(&ne_shared->hdr, sizeof ne_shared->hdr);

	shared_data=ne_shared;

	ht_viewergroup::initall(ifs);
}

void ht_ne::done()
{
	ht_viewergroup::done();
}
