/* 
 *	HT Editor
 *	htpal.h
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __HTPAL_H__
#define __HTPAL_H__

#include "common.h"

struct palette {
	char *name;
	int value;
};

/*
 *	CLASS palette_group
 */

typedef struct ipalette {
	ipalette *next;
	char *name;
	int palclass;
	int entries;
	palette *pal;
} ipalette;

class palette_group: public object {
protected:
	ipalette *pal;
	ipalette *enum_pal;

	void freeall();
	ipalette *icreate(char *name, int entries, int palclass);
	ipalette *icreate_copy(char *srcname, char *destname);
	ipalette *icreate_xcopy(char *srcname, char *destname, int entries);
public:
			void init();
	virtual	void done();
/* overwritten */
		   int load(ht_stream *f);
	virtual void store(ht_stream *f);
/* new */
	palette_group *copy();
	palette *create(char *name, int entries, int palclass);
	palette *create_copy(char *srcname, char *destname);
	palette *create_xcopy(char *srcname, char *destname, int entries);
	ipalette *enum_first();
	ipalette *enum_next();
	palette *get(char *name);
	int get_entry(palette *palette, int entry, char **name, int *value);
	ipalette *iget(char *name);
	void paste(palette_group *pg);
	int set_entry(palette *palette, int entry, char *name, int value);
};

extern palette_group *pal_grp;

#endif /* !__HTPAL_H__ */
