/*
 *   htkeyb.h - LINUX implementation
 */
 
/*
 * FIXME: keys with negative values are not (yet) usable under Linux...
 */ 

#ifndef __HTKEYB_H__
#define __HTKEYB_H__

#include "config.h"
#include CURSES_HDR
#undef clear
#undef move

#define K_Escape		'\e'
#define K_Return		0x0a
#define K_Space		 	0x20
#define K_Delete		KEY_DC
#define K_Insert		-2
#define K_BackSpace		KEY_BACKSPACE

#define HT_META_KEY(c) ((c) | 0x40000000)
#define HT_UNMETA_KEY(c) ((c) & (~0x40000000))
#define HT_IS_META_KEY(c) ((c) & 0x40000000)

// only works for A-Z !
#define HT_CONTROL_KEY(c) (char)(c-'A'+1)	

#define K_F1                   KEY_F(1)
#define K_F2                   KEY_F(2)
#define K_F3                   KEY_F(3)
#define K_F4                   KEY_F(4)
#define K_F5                   KEY_F(5)
#define K_F6                   KEY_F(6)
#define K_F7                   KEY_F(7)
#define K_F8                   KEY_F(8)
#define K_F9                   KEY_F(9)
#define K_F10                  KEY_F(10)
#define K_F11                  KEY_F(11)
#define K_F12                  KEY_F(12)
#define K_Home                 KEY_HOME
#define K_End                  KEY_END
#define K_Up                   KEY_UP
#define K_Down                 KEY_DOWN
#define K_Left                 KEY_LEFT
#define K_Right                KEY_RIGHT
#define K_PageUp               KEY_PPAGE
#define K_PageDown             KEY_NPAGE
#define K_Control_F5           -4
#define K_Tab		       '\t'
#define K_BackTab	       KEY_BTAB
#define K_Control_Left         -6
#define K_Control_Right        -7
#define K_Control_PageUp       HT_META_KEY(KEY_PPAGE)
#define K_Control_PageDown     HT_META_KEY(KEY_NPAGE)
#define K_Control_Up       	-8
#define K_Control_Down     	-9
#define K_Alt_F1		-10
#define K_Shift_Up       	-11
#define K_Shift_Down     	-12
#define K_Shift_Left       	KEY_SLEFT
#define K_Shift_Right     	KEY_SRIGHT
#define K_Shift_PageUp       	-15
#define K_Shift_PageDown     	-16
#define K_Alt_F3		-17
#define K_Shift_End       	KEY_SEND
#define K_Shift_Delete       	KEY_SDC
#define K_Control_Insert       	-20
#define K_Shift_Insert       	KEY_SIC
#define K_Shift_Home       	KEY_SHOME
#define K_Shift_F7       	-23

#define K_Alt_1                HT_META_KEY('1')
#define K_Alt_2                HT_META_KEY('2')
#define K_Alt_3                HT_META_KEY('3')
#define K_Alt_4                HT_META_KEY('4')
#define K_Alt_5                HT_META_KEY('5')
#define K_Alt_6                HT_META_KEY('6')
#define K_Alt_7                HT_META_KEY('7')
#define K_Alt_8                HT_META_KEY('8')
#define K_Alt_9                HT_META_KEY('9')
#define K_Alt_0                HT_META_KEY('0')
#define K_Alt_X                HT_META_KEY('X')

#define K_Control_K            HT_CONTROL_KEY('K')
#define K_Control_A            HT_CONTROL_KEY('A')
#define K_Control_F            HT_CONTROL_KEY('F')
#define K_Control_L            HT_CONTROL_KEY('L')
#define K_Control_O            HT_CONTROL_KEY('O')

int htkey2alt(int key);
int htalt2key(int key);

int htkeypressed();
int htgetkey();

int init_keyb();
int done_keyb();

#endif /* !__HTKEYB_H__ */
