/* 
 *	HT Editor
 *	viewers.h
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __VIEWERS_H__
#define __VIEWERS_H__

struct viewer_if;

#include "htstream.h"
#include "htviewer.h"

struct viewer_if {
	ht_view *(*init)(bounds *b, ht_stream *file, ht_group *group);
	void (*done)(ht_view *view);
};

extern viewer_if *viewer_ifs[];

/*
 *	CLASS ht_viewergroup
 */

class ht_viewergroup: public ht_xgroup {
	ht_stream *ht_viewergroup_stream;
	viewer_if **ifs;
	ht_view *views[32];
public:
			void	init(bounds *b, int options, char *desc, ht_stream *file, viewer_if **ifs);
	virtual	void done();
/* new */
			void initall(viewer_if **ifs);
			void doneall();
};

#endif /* !__VIEWERS_H__ */
